function [A,self] = PPIconstruction(geneCand,matrixCand,expr)
POI = geneCand;
% ppicand = [];
%
% parfor i = 1:size(PPIcand,1)
%     for j = 1:2
%         ppicand(i,j) = find(strcmp(PPIcand(i,j),POI));
%     end
% end

% innate_condition = {'0.5h','1h','2h','4h','6h','8h','12h','16h','18h'};
% adaptive_condition = {'2h','6h','12h','18h','24h','30h','36h','42h'};
% time = [0.5 1 2 4 6 8 12 16 18];

final = []; self = [];Final = {};final1 = [];
for i = 1:size(POI,1)
    %% fetch target and regulator's profiles
    target = POI(i,1);
    target_profile = expr(i,:);
    reg_index = find(matrixCand(i,:));
    reg_profile = expr(reg_index,:);
%     ub = max(max([target_profile;reg_profile]));
%     lb = min(min([target_profile;reg_profile]));
%     ub = ub/lb;
    if size(reg_index,2)==0
        continue
    end
    %% construct X, Phi based on the model
    num_para = size(reg_profile,1) + 1;
%     propotion = (max(time)-min(time))/(18-2);
%     h = 5*num_para*propotion;
%     n = min(time):((max(time)-min(time))/h):max(time);
%     target_profile_int = spline(time,target_profile,n);
%     reg_profile_int = spline(time,reg_profile,n);
%     [start,c] = min(find(n>=2));
%     [stop,c] = max(find(n<=18));
    X = target_profile';
        Phi = [reg_profile',ones(size(X,1),1)];
%     Phi = [reg_profile_int(:,start:stop-1)',target_profile_int(1,start:stop-1)',ones(size(X,1),1)];
    %     X = target_profile_int(1,2:end)';
    %     Phi = [reg_profile_int(:,1:end-1)',target_profile_int(1,1:end-1)',ones(size(X,1),1)];
    %% estimation
    %     Phi_lasso = Phi;
    %     Phi_lasso(:,end) = [];
    %     [B1,FitInfo1] = lasso(Phi_lasso,X);
    %     [B2,FitInfo2] = lassoglm(Phi_lasso,X);
    %     nsig = aictest(Phi_lasso,'fb');
    
    A = zeros(1,num_para);
    A(1,end) = -1;
    b = 0;
    options=optimset('Algorithm','active-set');
    C = Phi;
    d = X;
%     lbb = -1*ub*ones(num_para,1);
%     ubb = ub*ones(num_para,1);
    [x,resnorm] = lsqlin(C,d,A,b,[],[],[],[],[],options);
    [theta_AIC,phi_AIC,reg_id_AIC,cut_id_AIC,AIC_value]=AICfun_ForStepRegression_constrained(d,C,x,reg_index);
    [theta_pvalue,phi_pvalue,reg_id_pvalue,cut_id_pvalue,PPvalue]=pvalue_selection_constrained_gene(d,phi_AIC,theta_AIC,reg_id_AIC,1,0.05);
    %% PPI construction
    temp = [ones(size(reg_id_pvalue'))*i,reg_id_pvalue',theta_pvalue(1:end-1)];
    final = [final;temp];
    %     for j = 1:size(reg_id_pvalue',1)
    %         final = [final;i reg_id_pvalue(j) theta_pvalue(j)];
    %     end
    temp1 = [i theta_pvalue(end,1)];
    self = [self;temp1];
end
parfor i = 1:size(final,1)
    temp3 = [POI(final(i,1),1),POI(final(i,2),1),final(i,3)]
    Final = [Final;temp3];
end
Final = uptriangulize(Final);
parfor i = 1:size(Final,1)
    temp4 = [find(strcmp(Final(i,1),POI)), find(strcmp(Final(i,2),POI)), Final(i,3)]
    final1 = [final1;temp4];
end
I = cell2mat(final1(:,1));
J = cell2mat(final1(:,2));
S = cell2mat(final1(:,3));
A = sparse(I,J,S,size(POI,1),size(POI,1));
end